package se.su.dsv.scipro.daisyExternal;

import brave.SpanCustomizer;
import brave.http.HttpAdapter;
import brave.http.HttpClientParser;
import zipkin.TraceKeys;

class ExtendedHttpClientParser extends HttpClientParser {
    @Override
    public <Req> void request(final HttpAdapter<Req, ?> adapter, final Req req, final SpanCustomizer customizer) {
        super.request(adapter, req, customizer);
        final String url = adapter.url(req);
        if (url != null) {
            customizer.tag(TraceKeys.HTTP_URL, url);
        }
        final String method = adapter.method(req);
        if (method != null) {
            customizer.tag(TraceKeys.HTTP_METHOD, method);
        }
    }

    @Override
    protected <Req> String spanName(final HttpAdapter<Req, ?> adapter, final Req req) {
        return adapter.method(req) + " " + adapter.url(req);
    }
}
